BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want to built with jdk15 support, give rpmbuild option '--with jdk15'
%define with_jdk15 %{?_with_jdk15:1}%{!?_with_jdk15:0}
%define without_jdk15 %{!?_with_jdk15:1}%{?_with_jdk15:0}


Summary:        JBoss AOP Framework
Name:           jboss-aop
Version:        1.3.6
Release:        alt2_1jpp1.7
Epoch:          0
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
Source0:        jboss-aop-1.3.6-src.tar.gz
# cvs -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -r JBOSS_AOP_1_3_6 jboss-aop

Source1:	jboss-aop-1.3.6-buildmagic-autoload.properties
Source2:	jboss-aop-1.3.6-buildmagic-buildmagic.ent
Source4:	jboss-aop-1.3.6-buildmagic-common.properties
Source5:	jboss-aop-1.3.6-buildmagic-common.xml
Source6:	jboss-aop-1.3.6-buildmagic-libraries.ent
Source7:	jboss-aop-1.3.6-buildmagic-modules.ent
Source8:	jboss-aop-1.3.6-buildmagic-targets.ent
Source9:	jboss-aop-1.3.6-buildmagic-task.properties
Patch0:		jboss-aop-1.3.6-build_xml.patch
Patch1:		jboss-aop-1.3.6-XmlHelper.patch
Patch2:		jboss-aop-1.3.6-AnnotationDocletTagFactory.patch
Patch3:		jboss-aop-1.3.6-scripts.patch

BuildArch:      noarch
# general requires
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6.2
BuildRequires: jboss4-buildmagic-tasks
#OK
#BuildRequires:       ant-javamail
#BuildRequires:       ant-junit
#BuildRequires:       ant-nodeps
#BuildRequires:       ant-trax
#BuildRequires:       bsf
#BuildRequires:       junit
#BuildRequires:       xalan-j2
#BuildRequires:       xerces-j2
#BuildRequires:       xml-commons-apis
#BuildRequires:       xml-commons-resolver
%if %{with_jdk15}
#BuildRequires:       java-1.5.0-bea
%else
#BuildRequires:       java-1.4.2-bea
%endif
# framework requires
BuildRequires: jboss4-common
BuildRequires: concurrent
BuildRequires: gnu.trove
BuildRequires: javassist >= 0:3.1
BuildRequires: qdox >= 0:1.5
BuildRequires: xdoclet
# OK
# NO BuildRequires:       bsh
Provides:            jboss-aop-framework
Obsoletes:           jboss-aop-framework
Patch33: jboss-4-generic-alt-ant17support.patch
%add_findreq_skiplist /usr/share/%name/bin/*

%description
JBoss AOP is a 100%% Pure Java aspected oriented framework 
usuable in any programming environment or tightly integrated 
with our application server. Aspects allow you to more easily 
modularize your code base when regular object oriented 
programming just doesn't fit the bill. It can provide a 
cleaner separation from application logic and system code. 
It provides a great way to expose integration points into 
your software. Combined with JDK 1.5 Annotations, it also 
is a great way to expand the Java language in a clean 
pluggable way rather than using annotations solely for 
code generation. 


%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildRequires: java-javadoc

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.

%prep
%setup -qq -n jboss-aop-%{version}-src
for f in $(find . -name "*.jar"); do
	mv $f $f.no
done
mkdir -p tools/lib
pushd tools/lib
ln -sf $(build-classpath jboss4/jboss4-buildmagic-tasks) buildmagic-tasks.jar
popd
mkdir -p common/output/lib
pushd common/output/lib
ln -sf $(build-classpath jboss4/jboss-common) jboss-common.jar
popd
mkdir thirdparty
pushd thirdparty
mkdir -p ant/lib
pushd ant/lib
ln -sf $(build-classpath ant) .
popd
mkdir -p concurrent/lib
pushd concurrent/lib
ln -sf $(build-classpath concurrent) .
popd
mkdir -p javassist/lib
pushd javassist/lib
ln -sf $(build-classpath javassist) .
popd
mkdir -p junit/lib
pushd junit/lib
ln -sf $(build-classpath junit) .
popd
mkdir -p qdox/lib
pushd qdox/lib
ln -sf $(build-classpath qdox) .
popd
mkdir -p trove/lib
pushd trove/lib
ln -sf $(build-classpath gnu.trove) .
popd
mkdir -p xdoclet-xdoclet/lib
pushd xdoclet-xdoclet/lib
ln -sf $(build-classpath xdoclet/xdoclet) .
popd
popd

mkdir -p tools/etc/buildmagic
cp %{SOURCE1} tools/etc/buildmagic/autoload.properties
cp %{SOURCE2} tools/etc/buildmagic/buildmagic.ent
cp %{SOURCE4} tools/etc/buildmagic/common.properties
cp %{SOURCE5} tools/etc/buildmagic/common.xml
cp %{SOURCE6} thirdparty/libraries.ent
cp %{SOURCE7} tools/etc/buildmagic/modules.ent
cp %{SOURCE8} tools/etc/buildmagic/targets.ent
cp %{SOURCE9} tools/etc/buildmagic/task.properties

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch33 -p1

%build

BUILD_ID=`date -u +%Y%m%d%H%M`_%{version}-%{release}

export CLASSPATH=""
export JROCKITHOME=""
%if %{with_jdk15}
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
rpm -q --whatprovides java-1.5.0-bea && JROCKITHOME=%{_jvmdir}/java-1.5.0-bea
%else
export JAVA_HOME=/usr/lib/jvm/java-1.4.2
rpm -q --whatprovides java-1.4.2-bea && JROCKITHOME=%{_jvmdir}/java-1.4.2-bea
%endif

ant -Djrockit.home=${JROCKITHOME} all tests


%install

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

# install aop framework
install -m 644 output/lib/jboss-aop.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-%{version}.jar
install -m 644 output/lib/jdk14-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jdk14-pluggable-instrumentor-%{version}.jar
[ -f output/lib/jrockit-pluggable-instrumentor.jar ] && install -m 644 output/lib/jrockit-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jrockit-pluggable-instrumentor-%{version}.jar
%if %{with_jdk15}
install -m 644 output/lib/jboss-aop-jdk50.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-jdk50-%{version}.jar
install -m 644 output/lib/pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/pluggable-instrumentor-%{version}.jar
%endif

# create all versionless symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
install -m 755 src/resources/bin/*.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/bin

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}
install -m 644 RELEASE_NOTES.txt $RPM_BUILD_ROOT%{_docdir}/%{name}


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi


%files
%{_javadir}/%{name}
%dir %{_datadir}/%{name}/bin
%attr(0755,root,root) %{_datadir}/%{name}/bin/*.sh

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%doc %{_docdir}/%{name}

%changelog
* Tue Dec 18 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.3.6-alt2_1jpp1.7
- added hack around req.shell dependencies

* Thu Nov 01 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.3.6-alt1_1jpp1.7
- converted from JPackage by jppimport script

